
//Add Array.some function if not present
//http://developer.mozilla.org/en/docs/Core_JavaScript_1.5_Reference:Global_Objects:Array:some
if (!Array.prototype.some) {
	Array.prototype.some = function(fun /*, thisp*/) {
		var len = this.length;
		if (typeof fun != "function")
			throw new TypeError();
		
		var thisp = arguments[1];
		for (var i = 0; i < len; i++) {
			if (i in this && fun.call(thisp, this[i], i, this))
				return true;
		}
		
		return false;
	};
}

function load() {
	//Fetch data
	var http_request=new XMLHttpRequest();
	http_request.open('GET','http://www.startrek.com/startrek/view/index.html',false);
	http_request.send(null);
	
	if (http_request.status == 200) {
		var responseText=http_request.responseText;
		
		//Get question
		var str_question_match=[
			'<td height="30" valign="top"><span class="headlinewhite">Q:<\/span><\/td>\r\n      <td height="30" valign="top" style="padding-left:3px" class="mainwhite">',
			'<td height="45" valign="top"><span class="headlinewhite">Q:<\/span><\/td>\r\n      <td height="45" valign="top" style="padding-left:3px" class="mainwhite">'
		];
		var int_question_match;
		if (str_question_match.some(function(element) {
			if ((int_question_match=responseText.indexOf(element)) != -1) {
				int_question_match+=element.length;
				return true;
			}
		})) {
			var str_question=responseText.substr(int_question_match);
			str_question=str_question.substr(0,str_question.indexOf('<\/td>'));
			//str_question=str_question.replace(/href="\/startrek\//g,'target="blank" href="http://www.startrek.com/startrek/','g');
		} else {
			var str_question='Error locating question data.';
		}
		
		//Get answer
		var str_answer_match=[
			'<a href="javascript:answer();" class="triviaanswer" onmouseout="window.status=\'\'" onmouseover="window.status=\'The answer is: \' + this.innerHTML + \'!\';return true">'
		];
		var int_answer_match;
		if (str_answer_match.some(function(element) {
			if ((int_answer_match=responseText.indexOf(element)) != -1) {
				int_answer_match+=element.length;
				return true;
			}
		})) {
			var str_answer=responseText.substr(int_answer_match);
			str_answer=str_answer.substr(0,str_answer.indexOf('<\/a>'));
			//str_answer=str_answer.replace(/href="\/startrek\//g,'target="blank" href="http://www.startrek.com/startrek/','g');
		} else {
			var str_answer='Error locating answer data.';
		}
		
		//Get from
		var str_from_match=[
			'<td height="20" valign="bottom" colspan="2" class="mainwhite">\r\n      \r\n      From '
		];
		var int_from_match;
		if (str_from_match.some(function(element) {
			if ((int_from_match=responseText.indexOf(element)) != -1) {
				int_from_match+=element.length;
				return true;
			}
		})) {
			var str_from=FROM+' '+responseText.substr(int_from_match);
			str_from=str_from.substr(0,str_from.indexOf('\r\n'));
			//str_from=str_from.replace(/href="\/startrek\//g,'target="blank" href="http://www.startrek.com/startrek/','g');
		} else {
			var str_from='Error locating from data.';
		}
		
		//Strip tags, replace spaces, remove newlines
		str_question=str_question.replace(/<[^>]*>/gi,'').replace(/&nbsp;/g,' ').replace(/\n|\r/g,'');
		str_answer=str_answer.replace(/<[^>]*>/gi,'').replace(/&nbsp;/g,' ').replace(/\n|\r/g,'');
		str_from=str_from.replace(/<[^>]*>/gi,'').replace(/&nbsp;/g,' ').replace(/\n|\r/g,'');
		
		//Put stuff
		q.bold='true';
		q.innerText='Q:';
		question.innerText=str_question;
		a.innerText='A:';
		answer.innerText=str_answer;
		from.innerText=str_from;
		hover.visible='true';
		
		//Debug
		//alert('Q: '+str_question+'\n\nA: '+str_answer+'\n\n'+str_from);
	} else {
		q.innerText='There was a problem with the request: '+http_request.statusText;
	}
}

function showanswer() {
	hover.visible='false';
	answer.visible='true';
}

function hideanswer() {
	answer.visible='false';
	hover.visible='true';
}

function resize() {
	question.width=view.width-22;
	answer.width=view.width-22;
}
